#ifndef FIFO_FACTORY_H
#define FIFO_FACTORY_H

#include "Fifos.h"

template <typename T>
class FifoFactory
{
    public :
    enum FifoTypes
    {
        StlQueue,CirclingArray
    };

    static Fifo<T>* createOne (FifoTypes fifoType);
    static std::string fifoTypeToString(FifoTypes fifoType);
};


template <typename T>
Fifo<T>* FifoFactory<T>::createOne (FifoTypes fifoType)
{
    Fifo<T>* toReturn = NULL;
    switch (fifoType)
    {
        case StlQueue:
        {
            toReturn = new FifoStlQueue<T,-1>;
            break;
        }
        case CirclingArray:
        {
            toReturn = new FifoCirclingArray<T,-1,300>;
            break;
        }
        default :
        {
            assert(false);
            break;
        }
    }
    return toReturn;
}


template <typename T>
std::string FifoFactory<T>::fifoTypeToString(FifoTypes fifoType)    // todo : renvoyer une const std::string& en utilisant un dictionnaire... eventuellement avec une mthode template ?
{
    std::string toReturn;
    switch (fifoType)
    {
        case StlQueue:
        {
            toReturn = "FifoStlQueue";
            break;
        }
        case CirclingArray:
        {
            toReturn = "FifoCirclingArray";
            break;
        }
        default :
        {
            assert(false);
            break;
        }
    }
    return toReturn;
}

#endif //FIFO_FACTORY_H
