#ifndef FIFOTESTER_H
#define FIFOTESTER_H

#include "ResultCompiler.h"
#include "SingleGroupFifoTester.h"

class FifoTester
{
    public:
        FifoTester();
        virtual ~FifoTester();

    protected :
        boost::barrier* goFlag;
        boost::barrier* stopFlag;
        boost::barrier* waitToEnd;
        bool writingInterruptorFlag;
        bool readerInterruptorFlag;
        boost::posix_time::time_duration* waitingTime;
        boost::posix_time::time_duration* additionnalTimeToRead;

    public :
        boost::shared_ptr<ResultCompiler> go(int groupNb, int writingPerGroup, int readingPerGroup, int waitingTimeInSeconds, int additionalTime, int waitingTimeAfterWriteMillisec, int waitingTimeIfFifoIsEmptyMillisec,FifoFactory<int>::FifoTypes fifoType);

    protected :
        void initFlagsAndBarriers(int groupNb, int writingPerGroup, int readingPerGroup, int waitingTimeInSeconds, int additionalTime);
        void cleanFlagsAndBarriers();
        void startWriting();
        void stopWriting();
        void stopReading();
};



#endif // FIFOTESTER_H
