#ifndef YAMANLOGS87694786
#define YAMANLOGS87694786

#include <boost/static_assert.hpp>
#include <boost/algorithm/string/trim.hpp>
#include <string>
#include <iostream>
#include <sstream>

enum TypeOfLogs{
    ThreadStartAndStop,
    ThreadError,
    Evolution,
    Results,
    Final
};

template<TypeOfLogs type> class InternLog;

template<TypeOfLogs type> class Log{
    public :
    Log<type>& operator<< (const std::string& toLog)
    {
        InternLog<type> () << toLog;
        return *this;
    }
    Log<type>& operator<< (const int toLog)
    {
        std::ostringstream oss;
        oss << toLog;
        return (*this) << oss.str();
    };
    // attention, c'est crados. Ici je surcharge l'utilisation de std::endl (en fait de tout les manipulateurs, cf plus loin), sans
    // reproduire le comportement attendu (notament le flush). Idalement, je devrais :
    // - soit reproduire ce comportement (mais c'est trop couteux car le but de cette classe, c'est justement de me permettre
    //          de faire des modifications de logs d'une compil  l'autre.
    // - soit utiliser des "\n" dans le reste du code, mais c'est dur de s'empcher de coller des std::endl partout.

    typedef std::basic_ostream<char, std::char_traits<char> > StreamType;
    typedef StreamType& (*ManipType)(StreamType&);

    Log<type>& operator<< (ManipType manip)
    {
        ManipType manip2 = std::endl;
        assert (manip == manip2);           // pas trs joli hein ? Et  l'excution en plus. Si quelqu'un a une ide ...
        InternLog<type> () << "\n";
        return (*this);
    }
};


template<TypeOfLogs type> class InternLog{
    public :
        void operator<< (const std::string& toLog);
};
template<> class InternLog<ThreadStartAndStop>{
public :
    void operator<< (const std::string& toLog)
    {
        // std::cout << toLog;
    }
};
template<> class InternLog<ThreadError>{
public :
    void operator<< (const std::string& toLog)
    {
        std::cout << toLog;
    }
};
template<> class InternLog<Evolution>{
public :
    void operator<< (const std::string& toLog)
    {

        std::cout << toLog ;
    }
};
template<> class InternLog<Results>{
public :
    void operator<< (const std::string& toLog)
    {
        std::cout << toLog;
    }
};
#endif // YAMANLOGS87694786
