#ifndef RESULTCOMPILER_H
#define RESULTCOMPILER_H

#include "ResultSet.h"
#include "FifoFactory.h"
#include <boost/shared_ptr.hpp>
#include <list>

class ResultCompiler
{
    public:
        ResultCompiler(int groupNb, int writingPerGroup, int readingPerGroup, int waitingTimeInSeconds, int additionnalTimeToRead, int waitingTimeAfterWriteMillisec, int waitingTimeIfFifoIsEmptyMillisec,FifoFactory<int>::FifoTypes fifoType);
        virtual ~ResultCompiler();

    protected:
        std::list<boost::shared_ptr<ResultSet> > allsets;
        int groupNb;
        int writingPerGroup;
        int readingPerGroup;
        int waitingTimeInSeconds;
        int additionnalTimeToRead;
        int waitingTimeAfterWriteMillisec;
        int waitingTimeIfFifoIsEmptyMillisec;
        FifoFactory<int>::FifoTypes fifoType;

    public :
        void addSet(boost::shared_ptr<ResultSet> toAdd);
        void printStats();
};

#endif // RESULTCOMPILER_H
